"""
23 January 2012
James W. Rohlf
Updated 07 March 2012
Charlie Hill

reads an address table and parses out the register names that are
read enabled

executes a read of these registers
"""

import sys
import os
from PyChipsUser import *
import amc13

def readall(r,str):
    length=len(str)
    for i in xrange(length):
        r.append(amc13.read(str[i]))
def printlist(s,t):
    #[ [0,2,3,4,...] ]
    ns=len(s)
    nt=len(t)
    #i loops over registers
    if nt != 1: print "                        last      previous (most recent first)"
    for i in xrange(ns):
        print s[i],
        #j loops over data stored
        for j in xrange(nt):
            print " %08x"    %  t[nt-j-1][i],
#        if i==2 or i==6 or i==9: print "\n"
        else:
          print " "

# get an address table 
#addrTable = AddressTable("/home/daq/amc13_python/addresstables_amc13/AMC13_AddressTable_v01.txt")
"""
fdi={}
for dirname, dirnames, filenames in os.walk('../addresstables_amc13'):
    i=0
    for filename in filenames:
        #print os.path.join(dirname,filename)
        if filename.endswith(".txt"):
            fdi[i]=filename
            i +=1
n=len(fdi)
for i in xrange(n):
        print i, fdi[i]
print "Enter an integer to select an address table:"
file=input()
if file >=0 and file <=n:
    if file >= n:
        print "file selected not in list... quitting"
        sys.exit(1)
    print "you have selected address table", fdi[file]
    s='../addresstables_amc13/'+fdi[file]
f=open(s, 'r')
#
#f=open(table_name, 'r')
#f=open('/home/daq/amc13_python/addresstables_amc13/AMC13_AddressTable_V6_v01.txt', 'r')
addrTable = AddressTable(s)

# Create a ChipsBus bus to talk to your board.
# input the last number of the address

"""
sn = amc13.sn1()
t1, t2 = amc13.connect(sn)

while True:
    print "Type 't1' to access Virtex registers or 't2' to access Spartan registers"
    a = raw_input('>> ')
    if a == 't1':
        amc13 = t1
        f = open('../addresstables_amc13/AMC13_AddressTable_V6_v01.txt', 'r')
        break
    elif a == 't2':
        amc13 = t2
        f = open('../addresstables_amc13/AMC13_AddressTable_S6_v01.txt', 'r')
        break
    else:
        True
    
whole=f.read()
#print whole
linelist = whole.split("\n")
#print linelist[0]
nlines=len(linelist)
str=[]
#loop over lines in address table
for line in linelist:
    length =len(line)
    #print length
    list=line.split()
    #ifgore comment lines and blank lines
    if length !=0 and line[0] != '*':
        #use only read enabled registers
        if list[3]=='1':
            str.append(list[0])
#print str

print "Accessing AMC13 registers"
r=[]
t=[]
readall(r,str)
t.append(r)
#print t
#make another string list with padded blanks
strp=[]
for i in xrange(len(str)):
    strp.append(str[i])
    ipad=22-len(str[i])
    for j in range(ipad):
     strp[i]=strp[i]+' '

printlist(strp,t)
print "type <CR> for next read or 'spacebar' <CR> to exit"

while 1==1:
  c=raw_input()
  if c==' ': sys.exit(0)
  readall(r,str)
  t.append(r)
  printlist(strp,t)
  print "type <CR> for next read or 'spacebar' <CR> to exit"
  if len(t) >=6:
      tsave=t
      t=[]
      for i in xrange(5): t.append(tsave[i+1])
  if c==' ': sys.exit(0)

